//
//  VetAppAppDelegate.m
//  VetApp
//
//  Created by Victoria Chiu on 4/3/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "MainMenuController.h"
#import "VetAppAppDelegate.h"
#import "QandAController.h"


@implementation VetAppAppDelegate

@synthesize window;
@synthesize navigationController;
@synthesize myMainMenuController;
@synthesize globalID, globalTitle, globalDate;
@synthesize savedController, savedFilterController;
@synthesize email, pwoc, phoneNum;


#pragma mark -
#pragma mark Application lifecycle

- (void)applicationDidFinishLaunching:(UIApplication *)application {    
	globalID = [NSString alloc];
	globalTitle = [NSString alloc];
	globalDate = [NSString alloc];
	
	email = [NSString alloc];
	pwoc = [NSString alloc];
	phoneNum = [NSString alloc];
    
    // Override point for customization after app launch   
	MainMenuController *aMainMenuController = [[MainMenuController alloc]
											 initWithNibName:@"MainMenuController" bundle:[NSBundle mainBundle]];
	[self setMyMainMenuController:aMainMenuController];
	[aMainMenuController release];
	
	[window addSubview:[myMainMenuController view]];
	
	[window addSubview:[navigationController view]];
    [window makeKeyAndVisible];
}


- (void)applicationWillTerminate:(UIApplication *)application {
	// Save data if appropriate
}


#pragma mark -
#pragma mark Memory management

- (void)dealloc {
	[email dealloc];
	[pwoc dealloc];
	[phoneNum dealloc];
	[globalDate dealloc];
	[globalTitle dealloc];
	[globalID dealloc];
	[myMainMenuController release];
	[navigationController release];
	[window release];
	[super dealloc];
}


@end

