//
//  EditProfileController.m
//  VetApp
//
//  Created by Class Account on 4/29/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "EditProfileController.h"
#import "VetAppAppDelegate.h"


@implementation EditProfileController

@synthesize phoneTxt, emailTxt, pwocSC, appDelegate;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	appDelegate = (VetAppAppDelegate*)[[UIApplication sharedApplication] delegate];
	phoneTxt.text = appDelegate.phoneNum;
	emailTxt.text = appDelegate.email;
	if(appDelegate.pwoc == @"E-Mail"){
		pwocSC.selectedSegmentIndex = 1;
	}else{
		pwocSC.selectedSegmentIndex = 0;
	}
	self.view.backgroundColor = [UIColor groupTableViewBackgroundColor];
	self.navigationItem.title = @"Edit Profile";
	UIBarButtonItem *post = [[UIBarButtonItem alloc] initWithTitle:@"Save" style:UIBarButtonItemStyleBordered target:self action:@selector(save)];
	self.navigationItem.rightBarButtonItem = post;
	[post release];
    [super viewDidLoad];
}

- (BOOL)textFieldShouldReturn:(UITextField *)theTextField {
    if (theTextField == phoneTxt) {
        [phoneTxt resignFirstResponder];
    }else if (theTextField == emailTxt) {
        [emailTxt resignFirstResponder];
	}
    return YES;
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)save{
	appDelegate.phoneNum = phoneTxt.text;
	appDelegate.email = emailTxt.text;
	if(pwocSC.selectedSegmentIndex == 0){
		appDelegate.pwoc = @"Phone";
	}else{
		appDelegate.pwoc = @"E-Mail";
	}
	UINavigationController *navController = self.navigationController;
	
	// retain ourselves so that the controller will still exist once it's popped off
	[[self retain] autorelease];
	
	// Pop this controller and replace with another
	[navController popViewControllerAnimated:YES];
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[appDelegate dealloc];
	[phoneTxt dealloc];
	[emailTxt dealloc];
	[pwocSC dealloc];
    [super dealloc];
}


@end
