//
//  QandA.m
//  VetApp
//
//  Created by Victoria Chiu on 4/3/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "QandAController.h"
#import "VetAppAppDelegate.h"
#import "MainMenuController.h"
#import "RatingTableCell.h"


@implementation QandAController

//@synthesize scrollView;
//@synthesize myPostQuestionController;
@synthesize responseList, questionList, keyList, currentElementValue, table, myPostResponseController, appDelegate, attachmentLink;
//@synthesize label1;
//@synthesize label2;


 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        NSLog(@"hello");
		
		
		//NSMutableArray *question1 = [[NSMutableArray alloc] init];
		//[question1 addObject:@"qtitle"];
		//[question1 addObject:@"qdescrip"];
		//[question1 addObject:@"qdate"];
		
		
    }
    return self;
}
/*
- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName 
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName
	attributes:(NSDictionary *)attributeDict {
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string {
    currentElementValue = string;
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName {
	keyList = [[NSMutableArray alloc] init];
	questionList = [[NSMutableArray alloc] init];
	responseList = [[NSMutableArray alloc] init];
	
	NSArray *list1 = [[NSArray arrayWithObjects:@"Title: ", @"Description: ", @"Date: ", nil] retain];
	NSArray *list2 = [[NSArray arrayWithObjects:@"Name: ", @"Answer: ", @"Rating: ", @"Date: ", nil] retain];
	[keyList addObject:list1];
	[keyList addObject:list2];
	
    if([elementName isEqualToString:@"title"]) {
		NSArray *qTitle = [[NSArray arrayWithObjects: currentElementValue] retain];
		[questionList addObject:qTitle];
    }else if ([elementName isEqualToString:@"description"] == 1){
		NSArray *qDescription = [[NSArray arrayWithObjects: currentElementValue] retain];
		[questionList addObject:qDescription];
	}else if ([elementName isEqualToString:@"date"] == 1){
		[departureTimes addObject: currentElementValue];
	}else if ([elementName isEqualToString:@"answer"] == 1){
	}
}

- (void) runXMLParser {

	
    NSURL *url = [[NSURL alloc] initWithString:@"https://letmeintroduce.com/cs160/get_answers.php?id=1"];
    NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithContentsOfURL:url];
    
    // set the current view controller as the parser's delegate.
    [xmlParser setDelegate: self];
    
    //Start parsing the XML file.
    BOOL success = [xmlParser parse];
    if(success)
        NSLog(@"No Errors");
    else
        NSLog(@"Error Error Error!!!");
	printf("%d\n", [answersArray count]);
	
	for (int i = 0; i < [answersArray count]; i++) {
		
	}
	
	if([answersArray count] >= 2 ){
		destination1.text = [answersArray objectAtIndex:0];
		time1.text = [departureTimes objectAtIndex:1];
	}
	if([answersArray count] >= 4 ){
		destination2.text = [answersArray objectAtIndex:2];
		time2.text = [answersArray objectAtIndex:3];
	}
	
    [url release];
    [xmlParser release];
}
*/
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	
	appDelegate = (VetAppAppDelegate*)[[UIApplication sharedApplication] delegate];
	attachmentLink = @"None";
	age = @"";
	gender = @"";
	animalType = @"";
	breed = @"";
	
	keyList = [[NSMutableArray alloc] init];
	questionList = [[NSMutableArray alloc] init];
	responseList = [[NSMutableArray alloc] init];
	nameList = [[NSMutableArray alloc] init];
	answerList = [[NSMutableArray alloc] init];
	ratingList = [[NSMutableArray alloc] init];
	dateList = [[NSMutableArray alloc] init];
	idList = [[NSMutableArray alloc] init];
	myDescription = @"";
	
	[self refresh];
	
	/*
	answersArray = [[NSMutableArray alloc] init];
	[self runXMLParser];
    [super viewDidLoad];
	*/
	self.navigationItem.title = @"Question";
	UIBarButtonItem *post = [[UIBarButtonItem alloc] initWithTitle:@"Reply" style:UIBarButtonItemStyleBordered target:self action:@selector(posting)];
	self.navigationItem.rightBarButtonItem = post;
	[post release];
	
	PostResponseController *aPostResponseController = [[PostResponseController alloc]
													   initWithNibName:@"PostResponseController" bundle:[NSBundle mainBundle]];
	[self setMyPostResponseController:aPostResponseController];
	[aPostResponseController release];
	UIColor *tempColor = [[UIColor alloc] initWithRed:204.0 / 255 green:230.0 / 255 blue:255.0 / 255 alpha:1.0];
	//self.view.backgroundColor = tempColor;
	table.backgroundColor = tempColor;
	
	[super viewDidLoad];
	//UIScrollView *yourScrollview= [[UIScrollView alloc] initWithFrame:CGRectMake(0, 0, 320, 480)];
	//[scrollView setContentSize:CGSizeMake(320, 700)];
	
	/*
	UILabel *yourLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 100, 300, 50)];
	yourLabel.textAlignment = UITextAlignmentCenter;
	yourLabel.text = @"Here you write your text";
	yourLabel.textColor = [UIColor blackColor];
	[yourLabel setBackgroundColor:[UIColor orangeColor]];
	[self.view addSubview:yourLabel ];
*/
}

-(void)viewWillAppear:(BOOL)animated {
	[self refresh];
	[table reloadData];
}

- (void)refresh{
	[keyList removeAllObjects];
	[questionList removeAllObjects];
	[responseList removeAllObjects];
	[nameList removeAllObjects];
	[answerList removeAllObjects];
	[ratingList removeAllObjects];
	[dateList removeAllObjects];
	[idList removeAllObjects];
	attachmentLink = @"None";
	
	NSString *urlLink = [[NSString alloc] initWithFormat:@"https://letmeintroduce.com/cs160/get_answers.php?id=%@", appDelegate.globalID];
	
	NSURL *url = [[NSURL alloc] initWithString:urlLink];
    NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithContentsOfURL:url];
	
    
    // set the current view controller as the parser's delegate.
    [xmlParser setDelegate: self];
    
    //Start parsing the XML file.
    BOOL success = [xmlParser parse];
    if(success)
        NSLog(@"No Errors");
    else
        NSLog(@"Error Error Error!!!");   
	
	[url release];
    [xmlParser release];
	NSLog(@"asdf");
	printf("length: %d\n", [attachmentLink length]);
	NSLog(@"qwer");
	if([attachmentLink hasPrefix:@"\n"]){
		attachmentLink = @"None";
	}
	if([breed hasPrefix:@"\n"]){
		breed = @"N/A";
	}
	
	NSMutableArray *question1 = [[NSMutableArray arrayWithObjects: appDelegate.globalTitle, myDescription, animalType, breed, gender, age, attachmentLink, appDelegate.globalDate, nil] retain];
	
	
	for(int i = 0; i < [nameList count]; i++){
		printf("count: %d\n", [nameList count]);
		
		NSMutableArray *response1 = [[NSMutableArray arrayWithObjects: [nameList objectAtIndex:i],[answerList objectAtIndex:i], [ratingList objectAtIndex:i], [dateList objectAtIndex:i+1], nil] retain];
		[responseList addObject:response1];
		[response1 release];
	}
	NSLog(@"qwerty");
	
	
	NSArray *list1 = [[NSArray arrayWithObjects:@"Title: ", @"Description: ", @"Animal Type: ", @"Breed: ", @"Gender: ", @"Age: ", @"Attachment: ", @"Date: ", nil] retain];
	NSArray *list2 = [[NSArray arrayWithObjects:@"Name: ", @"Answer: ", @"Rating: ", @"Date: ", nil] retain];
	[keyList addObject:list1];
	[keyList addObject:list2];
	[questionList addObject:question1];
	NSLog(@"%d\n", [questionList count]);
	NSLog(@"%d\n", [responseList count]);
	
	[list1 release];
	[list2 release];
	[question1 release];
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
    currentElementValue = string;
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
    // parser has just finished reading the temperature_string element, so we set the value found
    //   as the label's text
    if([elementName isEqualToString:@"description"]) {
		myDescription = currentElementValue;
    }else if([elementName isEqualToString:@"name"]) {
		NSLog(currentElementValue);
		[nameList addObject:currentElementValue];
    }else if([elementName isEqualToString:@"answer"]) {
		[answerList addObject:currentElementValue];
    }else if([elementName isEqualToString:@"rating"]) {
		[ratingList addObject:currentElementValue];
    }else if([elementName isEqualToString:@"date"]) {
		[dateList addObject:currentElementValue];
    }else if([elementName isEqualToString:@"attachment_url"]) {
		attachmentLink = currentElementValue;
		NSLog(currentElementValue);
    }else if([elementName isEqualToString:@"id"]) {
		[idList addObject:currentElementValue];
    }else if([elementName isEqualToString:@"sex"]) {
		gender = currentElementValue;
    }else if([elementName isEqualToString:@"age"]) {
		age = currentElementValue;    
	}else if([elementName isEqualToString:@"animal_type"]) {
		animalType = currentElementValue;    
	}else if([elementName isEqualToString:@"breed"]) {
		breed = currentElementValue;    
	}
}

- (void)posting{
	UINavigationController *navController = self.navigationController;
	
	// retain ourselves so that the controller will still exist once it's popped off
	[[self retain] autorelease];
	
	// Pop this controller and replace with another
	[navController pushViewController:myPostResponseController animated:YES];
	
}



-(void) awakeFromNib{
	[super awakeFromNib];
}

#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	//NSLog(@"A");
    return ([responseList count] + [questionList count]);
	//return [questionList count];
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	//return 1;
	//return [[questionList lastObject] count];
	//NSLog(@"B");
	NSLog(@"Number of rows: %d\n", [[responseList lastObject] count] - 1);
    return (section == 0) ? [[questionList lastObject] count] : ([[responseList lastObject] count] - 1);
	
}

-(NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger) section {
	//NSLog(@"C");
	
	if (section == 0){
		if([appDelegate.globalID intValue]> 86){
				return @"Dr. John Smith asked:";
		}
		return @"Dr. iPhone User asked:";
	}
	else{
		if([appDelegate.globalID intValue]> 86){
			return @"Dr. John Smith responded:";
		}
		return [@"Dr. " stringByAppendingString:[[[responseList objectAtIndex:(section - 1)] objectAtIndex:0] stringByAppendingString:@" responded:"]];
	}
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	NSLog(@"a");
	if(indexPath.section == 0 && indexPath.row == 6){
		NSURL *url = [NSURL URLWithString:attachmentLink];
		
		if (![[UIApplication sharedApplication] openURL:url])
			
			NSLog(@"%@%@",@"Failed to open url:",[url description]);
	}
	if(indexPath.section != 0 && indexPath.row == 1){
		[self refresh];
		[table reloadData];
	}
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath  {
		//NSLog(@"D");
		NSString *label = (indexPath.section == 0) ? [[questionList lastObject] objectAtIndex:indexPath.row] : [[responseList objectAtIndex:(indexPath.section - 1)] objectAtIndex:(indexPath.row + 1)];
		if ([label length] == 0) {
			label = @"Some label";
		}
		CGFloat maxWidth = [UIScreen mainScreen].bounds.size.width - 160;
		CGFloat maxHeight = 9999;
		CGSize maximumLabelSize = CGSizeMake(maxWidth,maxHeight);
	
		CGSize expectedLabelSize = [label sizeWithFont:[UIFont systemFontOfSize:13] constrainedToSize:maximumLabelSize lineBreakMode:UILineBreakModeWordWrap]; 
	
		CGFloat height = expectedLabelSize.height + 20.0;
		return height;

}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
   
    static NSString *CellIdentifier = @"Cell";
	static NSInteger const ktitleLabelTag = 2;
	static NSInteger const kdataLabelTag = 3;
	NSString *titleValue;
	NSString *dataValue;
	UITableViewCell *cell;
	UIColor *tempColor = [[UIColor alloc] initWithRed:225.0 / 255 green:225.0 / 255 blue:225.0 / 255 alpha:1.0];
	
	
	if (indexPath.section == 0) { //The question asked
		titleValue = [[keyList objectAtIndex:indexPath.section] objectAtIndex:indexPath.row];
		dataValue = [[questionList lastObject] objectAtIndex:indexPath.row];
	}
	else { //The responses to the question
		titleValue = [[keyList lastObject] objectAtIndex:(indexPath.row+1)];
		dataValue = [[responseList objectAtIndex:(indexPath.section-1)] objectAtIndex:(indexPath.row + 1)];
	}
	
	if(indexPath.section != 0 && indexPath.row == 1){
		static NSString *CellIdentifier = @"ratingCell";
		RatingTableCell *cell2 = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
		
		if (!cell2) {
			NSArray *nibObjects = [[NSBundle mainBundle] loadNibNamed:@"RatingTableCell" owner:nil options:nil];
			NSLog(@"zxcvbnm");
			for (id currentObject in nibObjects) {
				NSLog(@"zxcvbnm");
				if ([currentObject isKindOfClass:[RatingTableCell class]]) {
					cell2 = (RatingTableCell *) currentObject;
					break;
				}
			}
		}

		cell2.questionID = [idList objectAtIndex:(indexPath.section-1)];
		cell2.rating.text = dataValue;
		cell2.contentView.backgroundColor = tempColor;
		return cell2;
	}else{
		UILabel *titleLabel = nil;
		UILabel *dataLabel = nil;
		cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
		//if (cell == nil) {
		if (YES) {
			cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
			if(indexPath.section != 0) 
				cell.contentView.backgroundColor = tempColor;
		
		
			titleLabel = [[[UILabel alloc] initWithFrame:CGRectMake(10, 9, 100, 29)] autorelease];
			titleLabel.tag = ktitleLabelTag;
			titleLabel.font = [UIFont boldSystemFontOfSize:12];
			titleLabel.lineBreakMode = UILineBreakModeWordWrap;
			titleLabel.numberOfLines = 0;
			CGSize maximumLabelSize = CGSizeMake(160,9999);
			CGSize expectedLabelSize = [titleValue sizeWithFont:titleLabel.font 
										  constrainedToSize:maximumLabelSize 
											  lineBreakMode:titleLabel.lineBreakMode]; 
			//NSLog(dataValue);
			//adjust the label the the new height.
			CGRect newFrame = titleLabel.frame;
			newFrame.size.height = expectedLabelSize.height;
			titleLabel.frame = newFrame;
			titleLabel.backgroundColor = [UIColor clearColor];
		
			[cell.contentView addSubview:titleLabel];
		
			dataLabel = [[[UILabel alloc] initWithFrame:CGRectMake(120, 9, 160, 29)] autorelease];
			dataLabel.tag = kdataLabelTag;
			dataLabel.font = [UIFont boldSystemFontOfSize:12];
			dataLabel.autoresizingMask = UIViewAutoresizingFlexibleRightMargin;
			dataLabel.textAlignment = UITextAlignmentRight;
			dataLabel.lineBreakMode = UILineBreakModeWordWrap;
			dataLabel.numberOfLines = 0;
			expectedLabelSize = [dataValue sizeWithFont:dataLabel.font 
										constrainedToSize:maximumLabelSize 
									  lineBreakMode:dataLabel.lineBreakMode]; 
			newFrame = dataLabel.frame;
			newFrame.size.height = expectedLabelSize.height;
			dataLabel.frame = newFrame;
			dataLabel.backgroundColor = [UIColor clearColor];
			
			if(indexPath.section != 0 || indexPath.row != 6){
				cell.selectionStyle = UITableViewCellSelectionStyleNone;
			}else{
				cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
			}
		
			[cell.contentView addSubview:dataLabel];
		}
		else {
			titleLabel = (UILabel *)[cell.contentView viewWithTag:ktitleLabelTag];
			dataLabel = (UILabel *)[cell.contentView viewWithTag:kdataLabelTag];
		}
		titleLabel.text = titleValue;
		dataLabel.text = dataValue;
	}
	
	//titleLabel.text = @"1";
	//dataLabel.text = @"1";
	//[questionLabel sizeToFit];
    return cell;
}

/*
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	
	//Get the selected country
	
	NSDictionary *dictionary = [listOfItems objectAtIndex:indexPath.section];
	NSArray *array = [dictionary objectForKey:@"Countries"];
	NSString *selectedCountry = [array objectAtIndex:indexPath.row];
	
	//Initialize the detail view controller and display it.
	DetailViewController *dvController = [[DetailViewController alloc] initWithNibName:@"DetailView" bundle:[NSBundle mainBundle]];
	dvController.selectedCountry = selectedCountry;
	[self.navigationController pushViewController:dvController animated:YES];
	[dvController release];
	dvController = nil;
}*/


/*
- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
    currentElementValue = string;
}
 */
/*
- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
    // parser has just finished reading the temperature_string element, so we set the value found
    //   as the label's text
    if([elementName isEqualToString:@"body"]) {
        [questionList addObject:currentElementValue];
    }else if([elementName isEqualToString:@"date"]) {
        [dateList addObject:currentElementValue];
	}else if ([elementName isEqualToString:@"id"]) {
		[idList addObject:currentElementValue];
	}
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[attachmentLink dealloc];
	[appDelegate dealloc];
	[myPostResponseController dealloc];
	[keyList dealloc];
	[responseList dealloc];
	[questionList dealloc];
	[table dealloc];
	[currentElementValue dealloc];
    [super dealloc];
}


@end
