//
//  VetAppAppDelegate.h
//  VetApp
//
//  Created by Victoria Chiu on 4/3/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//
#import "MainMenuController.h"
#import "SortByController.h"
#import "FilterByController.h"

@class MainMenuController;


@interface VetAppAppDelegate : NSObject <UIApplicationDelegate, UIScrollViewDelegate> {
    
    UIWindow *window;
    UINavigationController *navigationController;
	MainMenuController *myMainMenuController;
	NSString *globalID;
	NSString *globalTitle;
	NSString *globalDate;
	SortByController *savedController;
	FilterByController *savedFilterController;
	NSString *phoneNum;
	NSString *email;
	NSString *pwoc;
}

@property (nonatomic, retain) IBOutlet UIWindow *window;
@property (nonatomic, retain) IBOutlet UINavigationController *navigationController;
@property (nonatomic, retain) MainMenuController *myMainMenuController;
@property (nonatomic, retain) NSString *globalID;
@property (nonatomic, retain) NSString *globalTitle;
@property (nonatomic, retain) NSString *globalDate;
@property (nonatomic, retain) NSString *phoneNum;
@property (nonatomic, retain) NSString *email;
@property (nonatomic, retain) NSString *pwoc;
@property (nonatomic, retain) SortByController *savedController;
@property (nonatomic, retain) FilterByController *savedFilterController;


@end

