//
//  FilterByController.m
//  VetApp
//
//  Created by Class Account on 4/30/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "FilterByController.h"
#import "TextTableCell.h"
#import "VetAppAppDelegate.h"

@implementation FilterByController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}

- (IBAction)doneFilter {
	VetAppAppDelegate *appDelegate = (VetAppAppDelegate *)[[UIApplication sharedApplication] delegate];
	[appDelegate.savedFilterController dismissModalViewControllerAnimated:YES];	
	
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	//NSLog(@"A");
    return 5;
	//return [questionList count];
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	//return 1;
	//return [[questionList lastObject] count];
	//NSLog(@"B");
    return 1;
	
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath  {
	return 43;
	
}

-(NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger) section {
	//NSLog(@"C");
	if(section == 0){
		return @"Animal Type:";
	}else if(section == 1){
		return @"Breed:";
	}else if(section == 2){
		return @"Gender:";
	}else if(section == 3){
		return @"Age:";
	}else{
		return @"Type of Case:";
	}
	
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	[tableView deselectRowAtIndexPath:indexPath animated:YES];
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	static NSString *CellIdentifier = @"textCell";
	TextTableCell *cell2 = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (!cell2) {
		NSArray *nibObjects = [[NSBundle mainBundle] loadNibNamed:@"TextTableCell" owner:nil options:nil];
		for (id currentObject in nibObjects) {
			if ([currentObject isKindOfClass:[TextTableCell class]]) {
				cell2 = (TextTableCell *) currentObject;
				break;
			}
		}
	}
	if(indexPath.section == 0){
		cell2.textLabel.text = @"Select Animal Type";
	}else if(indexPath.section == 1){
		cell2.textLabel.text = @"Select Breed";
	}else if(indexPath.section == 2){
		cell2.textLabel.text = @"Select Gender";
	}else if(indexPath.section == 3){
		cell2.textLabel.text = @"Select Age";
	}else if(indexPath.section == 4){
		cell2.textLabel.text = @"Select Type of Case";
	}
	return cell2;
}


- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
