//
//  MainMenuController.h
//  VetApp
//
//  Created by Victoria Chiu on 4/3/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>

@class PostQuestionController;
@class QandAController;
@class VetAppAppDelegate;
@class SettingsController;
@class SortByController;
@class FilterByController;

@interface MainMenuController : UIViewController { //UIViewController
	PostQuestionController *myPostQuestionController;
	QandAController *myQandAController;
	NSMutableArray *questionList;
	NSMutableArray *dateList;
	NSMutableArray *idList;
	NSString *currentElementValue;
	UITableView *table;
	VetAppAppDelegate *appDelegate;
	SettingsController *mySettingsController;
	bool tableColor;
	SortByController *mySortByController;
	FilterByController *myFilterByController;
}

@property (nonatomic, retain) PostQuestionController *myPostQuestionController;
@property (nonatomic, retain) QandAController *myQandAController;
@property (nonatomic, retain) SortByController *mySortByController;
@property (nonatomic, retain) SettingsController *mySettingsController;
@property (nonatomic, retain) FilterByController *myFilterByController;
@property (nonatomic, retain) NSMutableArray *questionList;
@property (nonatomic, retain) NSMutableArray *dateList;
@property (nonatomic, retain) NSString *currentElementValue;
@property (nonatomic, retain) IBOutlet UITableView *table;
@property (nonatomic, retain) VetAppAppDelegate *appDelegate;

- (IBAction)onClickButton:(id)sender;
- (IBAction)openSettings:(id)sender;
- (IBAction)displaySortBy;
- (IBAction)displayFilterBy;
- (void)refresh;

@end