//
//  PostQuestionController.h
//  VetApp
//
//  Created by Victoria Chiu on 4/3/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>

@class AttachmentController;
@class VetAppAppDelegate;

@interface PostQuestionController : UIViewController <UITextFieldDelegate, UITextViewDelegate, UIScrollViewDelegate> {
	IBOutlet UIScrollView *scrollView;
	UITextField *description;
	UITextView *descriptionText;
	UITextField *animal;
	UITextField *age;
	UITextField *breed;
	UITextField *title;
	UISegmentedControl *sex;
	NSString *currentElementValue;
	NSString *currentID;
	AttachmentController *myAttachmentController;
	UISwitch *attach;
	VetAppAppDelegate *appDelegate;
}

@property (nonatomic, retain) UIScrollView *scrollView;
@property (nonatomic, retain) IBOutlet UITextField *description;
@property (nonatomic, retain) IBOutlet UITextField *animal;
@property (nonatomic, retain) IBOutlet UITextField *age;
@property (nonatomic, retain) IBOutlet UITextField *breed;
@property (nonatomic, retain) IBOutlet UITextField *title;
@property (nonatomic, retain) IBOutlet UITextView *descriptionText;
@property (nonatomic, retain) IBOutlet UISwitch *attach;
@property (nonatomic, retain) IBOutlet UISegmentedControl *sex;
@property (nonatomic, retain) AttachmentController *myAttachmentController;
@property (nonatomic, retain) VetAppAppDelegate *appDelegate;

- (void)posting;
- (NSString*)urlencode:(NSString *)url;
@end
