//
//  ProfileController.m
//  VetApp
//
//  Created by Class Account on 4/29/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ProfileController.h"
#import "QandAController.h"
#import "VetAppAppDelegate.h"
#import "MainMenuController.h"
#import "TextTableCell.h"
#import "EditProfileController.h"


@implementation ProfileController

@synthesize table, myEditProfileController, appDelegate;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	appDelegate = (VetAppAppDelegate*)[[UIApplication sharedApplication] delegate];
	appDelegate.phoneNum = @"(555)-555-5555";
	appDelegate.email = @"jsmith5728@gmail.com";
	appDelegate.pwoc = @"E-Mail";
	EditProfileController *aEditProfileController = [[EditProfileController alloc]
										 initWithNibName:@"EditProfileController" bundle:[NSBundle mainBundle]];
	[self setMyEditProfileController:aEditProfileController];
	[aEditProfileController release];
	
	self.navigationItem.title = @"Profile";
	UIBarButtonItem *post = [[UIBarButtonItem alloc] initWithTitle:@"Edit" style:UIBarButtonItemStyleBordered target:self action:@selector(openEdit)];
	self.navigationItem.rightBarButtonItem = post;
	[post release];
    [super viewDidLoad];
}

- (void)openEdit{
	
	[[self navigationController] pushViewController:myEditProfileController animated:YES];
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	//NSLog(@"A");
    return 4;
	//return [questionList count];
}

-(void)viewWillAppear:(BOOL)animated {
	[table reloadData];
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	//return 1;
	//return [[questionList lastObject] count];
	//NSLog(@"B");
    return 3;
	
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath  {
	return 43;
	
}

-(NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger) section {
	//NSLog(@"C");
	if (section == 0)
		return @"Personal Info:";
	else if (section == 1)
		return @"Education Info:";
	else if (section == 2)
		return @"Account Info:";
	else if (section == 3)
		return @"Contact Info:";
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	static NSString *CellIdentifier = @"textCell";
	TextTableCell *cell2 = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (!cell2) {
		NSArray *nibObjects = [[NSBundle mainBundle] loadNibNamed:@"TextTableCell" owner:nil options:nil];
		for (id currentObject in nibObjects) {
			if ([currentObject isKindOfClass:[TextTableCell class]]) {
				cell2 = (TextTableCell *) currentObject;
				break;
			}
		}
	}
	if(indexPath.section==0 && indexPath.row == 0){
		cell2.textLabel.text = @"Name:";
		cell2.textLabel2.text = @"John Smith";
	}else if(indexPath.section==0 && indexPath.row == 1){
		cell2.textLabel.text = @"Specialty:";
		cell2.textLabel2.text = @"Emergency Care";
	}else if(indexPath.section==0 && indexPath.row == 2){
		cell2.textLabel.text = @"Member Since:";
		cell2.textLabel2.text = @"02.23.10";
	}else if(indexPath.section==1 && indexPath.row==0){
		cell2.textLabel.text = @"Undergraduate:";
		cell2.textLabel2.text = @"UC Berkeley";
	}else if(indexPath.section==1 && indexPath.row==1){
		cell2.textLabel.text = @"Graduate:";
		cell2.textLabel2.text = @"UC San Francisco";
	}else if(indexPath.section==1 && indexPath.row==2){
		cell2.textLabel.text = @"Experience:";
		cell2.textLabel2.text = @"27 years";
	}else if(indexPath.section==2 && indexPath.row==0){
		cell2.textLabel.text = @"Average Rating:";
		cell2.textLabel2.text = @"93%";
	}else if(indexPath.section==2 && indexPath.row==1){
		cell2.textLabel.text = @"# of Questions:";
		cell2.textLabel2.text = @"14";
	}else if(indexPath.section==2 && indexPath.row==2){
		cell2.textLabel.text = @"# of Responses:";
		cell2.textLabel2.text = @"37";
	}else if(indexPath.section==3 && indexPath.row==0){
		cell2.textLabel.text = @"Phone #:";
		cell2.textLabel2.text = appDelegate.phoneNum;
	}else if(indexPath.section==3 && indexPath.row==1){
		cell2.textLabel.text = @"E-Mail:";
		cell2.textLabel2.text = appDelegate.email;
	}else if(indexPath.section==3 && indexPath.row==2){
		cell2.textLabel.text = @"Preferred Way of Contact:";
		cell2.textLabel2.text = appDelegate.pwoc;
	}
	cell2.accessoryType = UITableViewCellAccessoryNone;
	cell2.selectionStyle = UITableViewCellSelectionStyleNone;
	return cell2;
}



/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[appDelegate dealloc];
	[myEditProfileController dealloc];
	[table dealloc];
    [super dealloc];
}


@end
