//
//  SortByController.m
//  VetApp
//
//  Created by Class Account on 4/30/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "SortByController.h"
#import "TextTableCell.h"
#import "VetAppAppDelegate.h"


@implementation SortByController

@synthesize table;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	//self.navigationItem.title = @"Sort By";
	//UIBarButtonItem *post = [[UIBarButtonItem alloc] initWithTitle:@"Done" style:UIBarButtonItemStyleBordered target:self action:@selector(done)];
	//self.navigationItem.rightBarButtonItem = post;
	//[post release];
	whichRow = 1;
    [super viewDidLoad];
}

- (IBAction)doneSort {
	VetAppAppDelegate *appDelegate = (VetAppAppDelegate *)[[UIApplication sharedApplication] delegate];
	[appDelegate.savedController dismissModalViewControllerAnimated:YES];	
	
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	//NSLog(@"A");
    return 1;
	//return [questionList count];
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	//return 1;
	//return [[questionList lastObject] count];
	//NSLog(@"B");
    return 3;
	
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath  {
	return 43;
	
}

-(NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger) section {
	//NSLog(@"C");
	return @"Select Category:";
	
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	whichRow = indexPath.row;
	[tableView deselectRowAtIndexPath:indexPath animated:YES];
	[table reloadData];
	//[table reloadData];
	//VetAppAppDelegate *appDelegate = (VetAppAppDelegate *)[[UIApplication sharedApplication] delegate];
	//[appDelegate.savedController dismissModalViewControllerAnimated:YES];	
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	static NSString *CellIdentifier = @"textCell";
	TextTableCell *cell2 = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (!cell2) {
		NSArray *nibObjects = [[NSBundle mainBundle] loadNibNamed:@"TextTableCell" owner:nil options:nil];
		for (id currentObject in nibObjects) {
			if ([currentObject isKindOfClass:[TextTableCell class]]) {
				cell2 = (TextTableCell *) currentObject;
				break;
			}
		}
	}
	if(indexPath.row == 0){
		cell2.textLabel.text = @"Title";
	}else if(indexPath.row == 1){
		cell2.textLabel.text = @"Date";
	}else if(indexPath.row == 2){
		cell2.textLabel.text = @"Response Rating";
	}
	cell2.accessoryType = UITableViewCellAccessoryNone;
	if(indexPath.row == whichRow){
		cell2.accessoryType = UITableViewCellAccessoryCheckmark;
	}
	return cell2;
}



/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[table dealloc];
    [super dealloc];
}


@end
